//********************************************************************************************************************************
//*                                                                                                                              *
//*     Filesystem Dialogs Library 2.1.3.6840  3delite 2006-2024                                                                *
//*     See Filesystem Dialogs Library ReadMe.txt for details.                                                                   *
//*                                                                                                                              *
//* Licenses available for usage of this component:                                                                              *
//* Freeware License: 25                                                                                                        *
//* 	http://www.shareit.com/product.html?productid=300958160                                                                  *
//* Shareware License: 95                                                                                                       *
//* 	http://www.shareit.com/product.html?productid=300070165                                                                  *
//* Commercial License: 450                                                                                                     *
//* 	http://www.shareit.com/product.html?productid=300070166                                                                  *
//*                                                                                                                              *
//* Home page:                                                                                                                   *
//*                                                                                                                              *
//*     https://www.3delite.hu/Object Pascal Developer Resources/filesystemdialogs.html                                          *
//*                                                                                                                              *
//* If you have any questions or enquiries please mail: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

#pragma once

//* .dll file name
#define FILENAME_DLL_FILESYSTEM_DIALOGS_LIBRARY "FilesystemDialogs.dll"
#define FDLIBCALL __stdcall
#define GETFDLIBFUNCTION(f) *((void**)&f) = GetProcAddress(FilesystemDialogsLibraryDLLHandle, #f)

//* Exported function names
#define NAME_FD_OpenDialog              "FilesystemDialogs_OpenDialog"
#define NAME_FD_SaveDialog              "FilesystemDialogs_SaveDialog"
#define NAME_FD_FolderDialog            "FilesystemDialogs_FolderDialog"
#define NAME_FD_Settings                "FilesystemDialogs_SettingsWindow"
#define NAME_FD_FreeDialogResults       "FilesystemDialogs_FreeDialogResults"

#define FD_MAX_PATH                     MAX_PATH * 30

#define FDM_NAME_SETTINGS_CHANGED       "Filesystem Dialogs Settings Changed"

//* Pointer to TOpenDialogResults is in wParam
//* Pointer to TOpenDialogParams is in lParam
//* You get the messages in the hookproc and to the specified Parent window handle
#define FDM_BASE                      	2 * WM_USER + 1

//* Filesystem Dialogs results
//* Pointer to TOpenDialogResults in wParam
//* You need to specify the ParentWindow also or a hookproc
#define FDM_RESULTS                   	FDM_BASE + 1

//* Load settings, WPARAM = 0, LPARAM = 0
#define FDM_LOADSETTINGS      			FDM_BASE + 2

//* Free memory that you have allocated for the dialog('s params, results)
#define FDM_FREEMEM           			FDM_BASE + 3

//* The dialog form is closing
#define FDM_CLOSING           			FDM_BASE + 4

//* The dialog form's window handle in wParam, pointer to TOpenDialogParams is in lParam
#define FDM_WINDOW_HANDLE     			FDM_BASE + 5

//* Realing the integrated form to the parent
#define FDM_REALIGN_INTEGRATED_WINDOW 	FDM_BASE + 6

//* Sent on file name selection, file name is in wParam as PChar (unicode), item's PIDL in lParam
#define FDM_ON_SELECT_FILE_NAME			FDM_BASE + 7

//* Refresh folder
#define FDM_REFRESH_FOLDER 				FDM_BASE + 8

//* Used internally
#define FDM_THUMBNAIL_READY 			FDM_BASE + 9

//* Used internally
#define FDM_ADD_THUMBNAIL_FILENAME 		FDM_BASE+ 10

//* Used internally
#define FDM_THUMBNAILER_THREAD_FINISHED FDM_BASE + 11

//* Used internally
#define FDM_THUMBNAILER_CONTROL_THREAD_TERMINATE FDM_BASE + 12

//* Used internally
#define FDM_SECONDARYVIEWER_PICTURE_READY FDM_BASE + 13

//* Used internally
#define FDM_SECONDARYVIEWER_AUDIOPICTURE_READY FDM_BASE + 14

//* Used internally
#define FDM_VIEWER_AUDIOPICTURE_READY  	FDM_BASE + 15

//* Custom previewer query file, wParam = PChar file name, lParam = PIDL
#define FDM_PREVIEWER_CUSTOM_QUERY  	FDM_BASE + 16

//* Custom previewer open previewer, Wnd = handle for the panel, wParam = PChar file name, lParam = PIDL
#define FDM_PREVIEWER_CUSTOM_DISPLAY 	FDM_BASE + 17

//* Custom previewer close
#define FDM_PREVIEWER_CUSTOM_CLOSE  	FDM_BASE + 18

//* Custom previewer resized
#define FDM_PREVIEWER_CUSTOM_RESIZED 	FDM_BASE + 19

//* Used internally
#define FDM_VIEWER_AUDIOPICTURE_PROGRESS FDM_BASE + 20

//* Used internally
#define FDM_SECONDARYVIEWER_VIEWER_AUDIOPICTURE_PROGRESS FDM_BASE + 21

//* Navigate to folder specified as PIDL in WPARAM, LPARAM = 0
#define FDM_NAVIGATE_TO_PIDL = FDM_BASE + 22

//* Trigger sending of selected files and folders for hookproc, WPARAM = 0, LPARAM = 0
#define FDM_QUERY_SELECTED_ITEMS = FDM_BASE + 23

//* Abort (stop) listing a folder, WPARAM = 0, LPARAM = 0
#define FDM_CANCEL_LISTING_ITEMS = FDM_BASE + 24

//* Used internally
#define FDM_VIEWER_GIFANIM_READY = FDM_BASE + 25

//* Used internally
#define FDM_SECONDARYVIEWER_GIFANIM_READY = FDM_BASE + 26

//* Request the current folder, returns POpenDialogOnCurrentFolder in WPARAM, POpenDialogParams in LPARAM
#define FDM_GET_CURRENT_FOLDER = FDM_BASE + 27

//* A dialog window is activated, returns 0 in WPARAM, POpenDialogParams in LPARAM
#define FDM_WINDOW_ACTIVATED = FDM_BASE + 28

//* Activate a dialog window, WPARAM = 0, LPARAM = 0
#define FDM_WINDOW_ACTIVATE = FDM_BASE + 29

//* Select all files and folders, WPARAM = 0, LPARAM = 0
#define FDM_SELECT_ALL = FDM_BASE + 30

//* Invert selected and unselected files and folders, WPARAM = 0, LPARAM = 0
#define FDM_INVERT_SELECTION = FDM_BASE + 31

//* Invert selected and unselected files and folders, WPARAM = 0, LPARAM = POpenDialogSelectPattern
#define FDM_SELECT_PATTERN = FDM_BASE + 32

//* Current folder changed, WPARAM = PIDL, LPARAM = POpenDialogParams
#define FDM_CURRENT_FOLDER_CHANGED = FDM_BASE + 33

//* Editing text, WPARAM = 1 when started, 0 when exited, LPARAM = POpenDialogSelectPattern
#define FDM_IN_EDIT = FDM_BASE + 34

//* Deselect all files and folders, WPARAM = 0, LPARAM = 0
#define FDM_SELECT_NONE = FDM_BASE + 35

//* Used internally
#define FDM_FOLDER_SIZE_RESULT = FDM_BASE + 36

//* Get folder sizes, WPARAM = 0, LPARAM = 0
#define FDM_COUNT_FOLDER_SIZES = FDM_BASE + 37

//* Display the search panel, WPARAM = 0, LPARAM = 0
#define FDM_SHOW_SEARCH_PANEL = FDM_BASE + 38

//* Add a PIDL, WPARAM = PIDL, LPARAM = 0
#define FDM_ADD_PIDL_TO_LIST = FDM_BASE + 39

//* Search completed, WPARAM = 0, LPARAM = 0
#define FDM_SEARCH_COMPLETED = FDM_BASE + 40

//* Search completed, WPARAM = TFDSearchProgress, LPARAM = 0
#define FDM_SEARCH_PROGRESS = FDM_BASE + 41

//* Style changed, WPARAM = TFDStyleChanged, LPARAM = 0
#define FDM_STYLE_CHANGED = FDM_BASE + 42

//* Host, parent window, handle changed, WPARAM = NewHandle, LPARAM = 0
#define FDM_HOST_HANDLE_CHANGED = FDM_BASE + 43

//* Reference to dialog class instance, WPARAM = TFormFileDialog, LPARAM = POpenDialogParams
#define FDM_DIALOG_INSTANCE = FDM_BASE + 44

//* Pop-up settings menu, WPARAM = X, LPARAM = Y
#define FDM_DIALOG_POPUP_SETTINGS_MENU = FDM_BASE + 45

#include <wtypes.h>
typedef unsigned __int64 QWORD;

//* Many of the following flags are not supported (legacy Windows flags), if any of the missing flags are needed, please contact me.
typedef enum
{
	ofReadOnly = 1,
	ofOverwritePrompt = 1 << 1,
	ofHideReadOnly = 1 << 2,
	ofNoChangeDir = 1 << 3,
	ofShowHelp = 1 << 4,
	ofNoValidate = 1 << 5,
	ofAllowMultiSelect = 1 << 6,
	ofExtensionDifferent = 1 << 7,
	ofPathMustExist = 1 << 8,
	ofFileMustExist = 1 << 9,
	ofCreatePrompt = 1 << 10,
	ofShareAware = 1 << 11,
	ofNoReadOnlyReturn = 1 << 12,
	ofNoTestFileCreate = 1 << 13,
	ofNoNetworkButton = 1 << 14,
	ofNoDereferenceLinks = 1 << 15,
	ofEnableIncludeNotify = 1 << 16,
	ofDontAddToRecent = 1 << 17,
	ofForceShowHidden = 1 << 18,
	ofNotModal = 1 << 19,				//* Not modal dialogs - user can access the app.'s UI
	ofNoClose = 1 << 20,                //* Dialog will not close after double clicking or clicking on 'Open/Save' button - usefull with the 'ofNotModal' flag
	ofIntegrate = 1 << 21,              //* The dialog will appear in the control specified by 'TOpenDialogParams.ParentWindow' - use with 'ofNotModal' and 'ofNoClose' flag
	ofStayOnTop = 1 << 22,              //* The dialog will stay on top of other windows
	ofNoCloseButton = 1 << 23,          //* Not possible to close the dialog if 'ofIntegrate' is used - usefull with the 'ofNotModal' flag
	ofOnSelectFilename = 1 << 24,       //* When user selects a file (clicks on it) the hookproc will be called and/or message will be sent to the 'ParentHandle' - usefull with the 'ofNotModal' flag
	ofCompatibilityMode = 1 << 25,
	ofCustomFileInfo = 1 << 26,         //* Custom file info is implemented, 'TOpenDialogParams.FileInfoHookProc' must be assigned
	ofCustomThumbnail = 1 << 27,        //* Custom thumbnail is implemented, 'TOpenDialogParams.FileThumbnailHookProc' must be assigned
	ofCustomPreViewer = 1 << 28,        //* Custom viewer is implemented, hookproc must be assigned
	ofInitialFolderIsPIDL = 1 << 29,    //* 'TOpenDialogParams.InitialDir' is not a pointer to a string but is a PIDL
	ofReturnPIDLs = 1 << 30          	//* Only works with open and folder dialog, also file(s) must exist
	ofBrowseArchives = 1 << 31       	//* Only works with open dialog and with 'ofReturnPIDLs'
} *POpenOption, TOpenOption;

typedef enum
{
	ofExNoPlacesBar = 1, 		// Not used
	ofExNoStatusBar = 1 << 1,
	ofExNoDrivesFavsRecents = 1 << 2,
	ofExNoFileName = 1 << 3,
	ofExNoFilter = 1 << 4,
	ofExNoToolBar = 1 << 5,
	ofExNoAddToFavs = 1 << 6,
	ofExNoTreeViewAndToolBar = 1 << 7,
	ofExNoPathAndFilter = 1 << 8,
	ofExNoTextButtons = 1 << 9,
	ofExNoOpenButtons = 1 << 10
} *PTOpenOptionEx, TOpenOptionEx;

//* from CommDlg.pas
typedef UINT(__stdcall *OFNHookProc)(HWND Wnd, UINT Msg, WPARAM wParam, LPARAM lParam);  //* stdcall

//* Hookproc functions
typedef BOOL(__stdcall *FDFileInfoHookProc)(LPWSTR FileName, void* PIDL, LPCTSTR* FileInformation, void* User);
typedef BOOL(__stdcall *FDFileThumbnailHookProc)(LPWSTR FileName, void* PIDL, int Width, int Height, void* Thumbnail, __int64* OriginalWidth, __int64* OriginalHeight, void* User);

typedef enum
{
	fsdtOpenDialog = 0,
	fsdtSaveDialog = 1,
	fsdtFolderDialog = 2
} *PFSDialogType, TFSDialogType;

#define FD_DW_DEFAULT = 0x00000000

typedef struct {
	DWORD UIColor;                              //* ARGB (use FD_DW_DEFAULT = no change)
	DWORD UIFontColor;                          //* ARGB
	DWORD ListerBckgColor;                      //* ARGB
	DWORD ListerFontColor;                      //* ARGB
	BOOL ListerGridLines;
	DWORD ListerHeaderGradientTopColor;         //* ARGB
	DWORD ListerHeaderGradientBottomColor;      //* ARGB
	DWORD ListerHeaderBrightColor;              //* ARGB
	DWORD ListerHeaderDarkColor;                //* ARGB
	DWORD ListerHeaderFontColor;                //* ARGB
	char ListerSelectionAlpha;                  //* A
	DWORD ListerSelectionGradientTopColor;      //* ARGB
	DWORD ListerSelectionGradientBottomColor;   //* ARGB
	DWORD ListerSelectionFrameColor;            //* ARGB
	char ListerHotTrackAlpha;                   //* A
	DWORD ListerHotTrackGradientTopColor;       //* ARGB
	DWORD ListerHotTrackGradientBottomColor;    //* ARGB
	DWORD ListerHotTrackFrameColor;             //* ARGB
	LPWSTR VCLStyleTheme;                       //* For example 'AQUA GRAPHITE' or a file name of a Delphi style file 'C:\Carbon.vsf'
} *POpenDialogAppearance, TOpenDialogAppearance;


//* Filesystem dialog Open file/Save file/Folder dialog parameters
typedef struct {
	LPWSTR DefaultExt;          					//* Default extension
	LPWSTR FileName;            					//* Default file name for Open/Save and Initial dir
	LPWSTR Filters;              					//* Filters eg.: 'Image files (*.bmp,*.jpg)|*.bmp;*.jpg|All files|*.*'
	int FilterIndex;           						//* Filter to use default, 1-first, 2-second...
	int HelpContext;           						//* Help context (not yet implemented)
	LPWSTR InitialDir;          					//* Initial folder, this is extracted first from FileName, if no FileName specified settings are used to decide which folder to use, if 'ofInitialFolderIsPIDL' is set this should be a pointer to ItemIDList (a PItemIDList)
	int Options;       								//* TOpenOptions: Dialog options (not all implemented so far), OR TOpenOption flags together
	int OptionsEx;             						//* Extra Dialog options, specify panels to hide (not all implemented), OR TOpenOptionEx flags together
	LPWSTR Title;               					//* Title to display as window's caption
	HWND ParentWindow;         						//* Parent window handle (needed for HookProc)
	GUID DialogGUID;          						//* Specifically identificate the dialog (you can get the same dialog always with this flag)
	OFNHookProc HookProc;      						//* Hookproc (for not modal mode, ParentWindow handle is also needed)
	int DialogType;  								//* Type of the dialog: Open/Save/Folder
	void* User;            							//* User variable
	FDFileInfoHookProc FileInfoHookProc;			//* Callback that gives back custom file info
	LPWSTR FileInfoColumnName;  					//* Column name used for custom file info
	FDFileThumbnailHookProc FileThumbnailHookProc; 	//* Callback that gives back thumbnail
	POpenDialogAppearance Appearance;				//* Set to nil to use default settings
	LPWSTR AdditionalParameters;                    //* String list of additional parameters
} *POpenDialogParams, TOpenDialogParams;

//* Filesystem dialog result
typedef struct {
	BOOL Successfull;          	//* True: User pressed the Open/Save, False: User pressed Cancel, closed the window or error (there is a fallback to comdlg32.dll though)
	LPWSTR FileName;           	//* The filename the user selected (only one) ending with a double null
	QWORD FileNameSize;    		//* FileName size in bytes (should be always at least MAX_PATH)
	UINT FileCount;           	//* Number of files, if user selected multiple files then FileCount > 1
	LPWSTR FileNames;           //* List of files in format "C:\Dir\Data.txt" separated by null characters ending with a double null
	QWORD FileNamesSize;    	//* FileNames size in bytes (it's up to you to validate last entry if all selected filenames don't fit into the FileNames)
	int FilterIndex;           	//* Filter's index the user selected 1-first, 2-second, etc...
} *POpenDialogResults, TOpenDialogResults;

//* FDM_ON_SELECT_FILE_NAME in WPARAM
typedef struct {
	LPWSTR FileName;            //* The filename the user selected (only one)
	void* PIDL;        			//* File's item id list (PIDL)
} *POpenDialogOnSelectFileName, TOpenDialogOnSelectFileName;

//* FDM_GET_CURRENT_FOLDER in WPARAM
typedef struct {
	LPWSTR Folder;            	//* The full path the user selected (only one)
	void* PIDL;        			//* Folder's PIDL
} *POpenDialogOnCurrentFolder, TOpenDialogOnCurrentFolder;

//* FDM_SELECT_PATTERN in LPARAM
typedef struct {
	LPWSTR Pattern;            	//* Pattern string
	BOOL CaseSensitive;        			//*
} *POpenDialogSelectPattern, TOpenDialogSelectPattern;

//* FDM_STYLE_CHANGED in WPARAM
typedef struct {
	LPWSTR StyleName;
} *PFDStyleChanged, TFDStyleChanged;

typedef BOOL(FDLIBCALL *t_OpenDialog)(TOpenDialogParams Params, POpenDialogResults Results);
typedef BOOL(FDLIBCALL *t_SaveDialog)(TOpenDialogParams Params, POpenDialogResults Results);
typedef BOOL(FDLIBCALL *t_FolderDialog)(TOpenDialogParams Params, POpenDialogResults Results);
typedef BOOL(FDLIBCALL *t_FilesystemDialogsSettings)(LPWSTR Params);
typedef BOOL(FDLIBCALL *t_FreeDialogResults)(POpenDialogResults Struct);

//* Exported functions
#ifdef __cplusplus
extern "C" {
#endif

	static HMODULE FilesystemDialogsLibraryDLLHandle = NULL;
	BOOL FilesystemDialogsLibraryDLLLoaded = FALSE;

	t_OpenDialog FilesystemDialogs_OpenDialog = NULL;
	t_SaveDialog FilesystemDialogs_SaveDialog = NULL;
	t_FolderDialog FilesystemDialogs_FolderDialog = NULL;
	t_FilesystemDialogsSettings FilesystemDialogs_Settings = NULL;
	t_FreeDialogResults FilesystemDialogs_FreeDialogResults = NULL;

#ifdef __cplusplus
}
#endif

BOOL InitFilesystemDialogsLibrary()
{
	FilesystemDialogsLibraryDLLHandle = LoadLibrary(FILENAME_DLL_FILESYSTEM_DIALOGS_LIBRARY);
	if (NULL != FilesystemDialogsLibraryDLLHandle)
	{
		(void*)FilesystemDialogs_OpenDialog = GetProcAddress(FilesystemDialogsLibraryDLLHandle, NAME_FD_OpenDialog);
		(void*)FilesystemDialogs_SaveDialog = GetProcAddress(FilesystemDialogsLibraryDLLHandle, NAME_FD_SaveDialog);
		(void*)FilesystemDialogs_FolderDialog = GetProcAddress(FilesystemDialogsLibraryDLLHandle, NAME_FD_FolderDialog);
		(void*)FilesystemDialogs_Settings = GetProcAddress(FilesystemDialogsLibraryDLLHandle, NAME_FD_Settings);
		(void*)FilesystemDialogs_FreeDialogResults = GetProcAddress(FilesystemDialogsLibraryDLLHandle, NAME_FD_FreeDialogResults);
		if ((NULL == FilesystemDialogs_OpenDialog)
			|| (NULL == FilesystemDialogs_SaveDialog)
			|| (NULL == FilesystemDialogs_FolderDialog)
            || (NULL == FilesystemDialogs_Settings)
			|| (NULL == FilesystemDialogs_FreeDialogResults)
			)
		{
			FilesystemDialogsLibraryDLLLoaded = FALSE;
			}
		else
		{
			FilesystemDialogsLibraryDLLLoaded = TRUE;
		}
	}
	return FilesystemDialogsLibraryDLLLoaded;
}

BOOL FreeFilesystemDialogsLibrary()
{
	if (NULL != FilesystemDialogsLibraryDLLHandle)
	{
		FilesystemDialogsLibraryDLLLoaded = !FreeLibrary(FilesystemDialogsLibraryDLLHandle);
	}
	return !FilesystemDialogsLibraryDLLLoaded;
}

