// FSDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FSD.h"
#include "FSDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

HWND CFSDDlg::m_FDWinHandle = NULL;
CFSDDlg *CFSDDlg::m_pInstance = NULL;

CFSDDlg::CFSDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFSDDlg::IDD, pParent)
	, m_cbAllowMultiple(0)
	, m_cbNotModal(0)
	, m_cbNoClose(0)
	, m_cbStayOnTop(0)
	, m_cbIntegrate(0)
	, m_cbSelectFileName(0)
	, m_nFilterIndex(0)
	, m_strFileName(_T(""))
	, m_strFilters(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pInstance = this;
}

void CFSDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ED_STATUS, m_status);
	DDX_Check(pDX, IDC_CB_MULTIPLE_SELECTIONS, m_cbAllowMultiple);
	DDX_Check(pDX, IDC_CB_OFNOTMODAL, m_cbNotModal);
	DDX_Check(pDX, IDC_CB_NOCLOSE, m_cbNoClose);
	DDX_Check(pDX, IDC_CB_STAYONTOP, m_cbStayOnTop);
	DDX_Check(pDX, IDC_CB_OFINTEGRATE, m_cbIntegrate);
	DDX_Check(pDX, IDC_CB_SELECTFILENAME, m_cbSelectFileName);
	DDX_Text(pDX, IDC_ED_FILENAME, m_strFileName);
	DDX_Text(pDX, IDC_ED_FILTERS, m_strFilters);
	DDX_Text(pDX, IDC_ED_FILTERINDEX, m_nFilterIndex);
	DDX_Control(pDX, IDC_INTEGRATE_PARENT, m_integrateParent);
	DDX_Control(pDX, IDC_GRP_OPTIONS, m_optionsGroup);
}

BEGIN_MESSAGE_MAP(CFSDDlg, CDialog)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_SETTINGS, &CFSDDlg::OnBnClickedBtnSettings)
	ON_BN_CLICKED(IDC_BTN_OPEN_DLG, &CFSDDlg::OnBnClickedBtnOpenDlg)
	ON_BN_CLICKED(IDC_BTN_SAVE_DLG, &CFSDDlg::OnBnClickedBtnSaveDlg)
	ON_BN_CLICKED(IDC_BTN_FOLDER_DLG, &CFSDDlg::OnBnClickedBtnFolderDlg)
	ON_WM_SIZING()
END_MESSAGE_MAP()



/*****************************************************************************************
* Purpose:		Initialize the dialog.
* Returns:		See MSDN.
*****************************************************************************************/
BOOL CFSDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_strFileName = _T("C:\\File.txt");
	m_strFilters = _T("Text files (*.txt)|*.txt|Picture files (*.jpg,*.bmp,*.png)|*.jpg;*.bmp;*.png|Audio files (*.mp3,*.flac)|*.mp3;*.flac|All files|*.*");
	m_nFilterIndex = 2;

	if (!FileSystemDialogs::InitFileSystemDialogsLibrary())
	{
		CString strErrorMsg;
		strErrorMsg.Format(_T("Error loading %s!"), FILENAME_DLL_FD);
		AfxMessageBox(strErrorMsg);
		PostQuitMessage(0);
	}

	UpdateData(FALSE);

	DoLayout();

	return TRUE;  // return TRUE  unless you set the focus to a control
}


/*****************************************************************************************
* Purpose:		FileSystem Dialogs hook procedure
* Params:		TODO
* Returns:		TODO
*****************************************************************************************/
UINT __stdcall CFSDDlg::OFNHookProc(HWND Wnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	POpenDialogResults Res;
	LPTSTR Text;
	LPVOID Struct;

	switch(Msg)
	{
	case FDM_RESULTS:
		//* Sent results

		Res = (POpenDialogResults)wParam;
        //* Extract first! filename
        Text = Res->FileName;
		AppendStatus(Text);
		break;

	case FDM_ON_SELECT_FILE_NAME:
		//* User selected a file
        Text = (LPTSTR)wParam;
        AppendStatus(Text);
		break;

	case FDM_FREEMEM:
		//* Free the memory as it is not needed anymore

        Struct = (LPVOID)wParam;
        //* Free memory
		FileSystemDialogs::FilesystemDialogs_FreeDialogResults((POpenDialogResults)Struct);
		break;

    //* The window handle is sent back
	case FDM_WINDOW_HANDLE:
        m_FDWinHandle = (HWND)wParam;
		break;
	}

	return 0;
}

/*****************************************************************************************
* Purpose:		Appends a new line to the Status text field.
* Parameters:	szTextToAppend - text to be appended.
*****************************************************************************************/
void CFSDDlg::AppendStatus(LPCTSTR szTextToAppend)
{
	CString strCurrentStatus;
	m_pInstance->m_status.GetWindowText(strCurrentStatus);
	strCurrentStatus += szTextToAppend;
	strCurrentStatus += _T("\r\n");
	m_pInstance->m_status.SetWindowText(strCurrentStatus);
	m_pInstance->m_status.PostMessage(WM_VSCROLL, SB_BOTTOM, 0);
}

/*****************************************************************************************
* Purpose:		Click handler for the "OpenDialog" button.
*****************************************************************************************/
void CFSDDlg::OnBnClickedBtnOpenDlg()
{
	LPTSTR pName;
	BOOL Success;

	UpdateData();
	//* Set params
	::ZeroMemory(&Params, sizeof(Params));
	Params.FileName = m_strFileName;
	Params.Filters = m_strFilters;
	Params.FilterIndex = m_nFilterIndex;

    //* Multi or single
    if(m_cbAllowMultiple)
	{
        Params.Options |= ofAllowMultiSelect;
	}

    //* Modal or not (the NOT modal form is the suggested methode)
    //* This requires a Handle which to the message will be sent and/or a HookProc
    //* This is needed to free the resources at the session end
	if(m_cbNotModal)
	{
        Params.Options |= ofNotModal;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
        Params.HookProc = OFNHookProc;
	}

    //* Browser mode
	if(m_cbNoClose)
	{
		Params.Options |= ofNoClose;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
        Params.HookProc = OFNHookProc;
	}

	//* Stay on top?
    if(m_cbStayOnTop)
	{
        Params.Options |= ofStayOnTop;
	}

	//* Integrate the dialog into a parent panel
	if(m_cbIntegrate)
	{
		Params.Options |= ofIntegrate;
		//* Needed for non-Delphi host apps
		Params.Options |= ofCompatibilityMode;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
	}

    //* Send a message when selection changes
    //* This requires a Handle which to the message will be sent and/or a HookProc
    if(m_cbSelectFileName)
	{
		Params.Options |= ofOnSelectFileName;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
		Params.HookProc = OFNHookProc;
	}

    //* Display custom information for every file
    //if(m_cbCustomFileInfo)
	//{
	//	Params.Options |= ofCustomFileInfo;
    //    Params.FileInfoHookProc = FileInfoHookProc;
	//	Params.FileInfoColumnName = 'Our custom info';
	//}

    //* Identify this dialog (In VC++ Tools/Create GUID creates a new GUID)
	// {D63D4348-B39B-4605-A015-21B1A730ED2A}
	static const GUID id =
		{ 0xd63d4348, 0xb39b, 0x4605, { 0xa0, 0x15, 0x21, 0xb1, 0xa7, 0x30, 0xed, 0x2a } };
    Params.DialogGUID = id;

    //* The app isn't commercial else you need a license
    Params.AllowTIFFLZW = true;

	//* Set up result structure
	::ZeroMemory(&Results, sizeof(Results));

    //* Inititalize the result structure (memory allocation)
	FileSystemDialogs::FilesystemDialogs_InitDialogResults(&Results, 1000);

    //* Call OpenDialog()
    Success = FileSystemDialogs::FilesystemDialogs_OpenDialog(Params, &Results);

    //* Use result
    if(Results.Successfull)
	{
        //* Single file
		m_strFileName = Results.FileName;

        //* Extract files (multiple) ending with a double null
		m_status.Clear();
        pName = Results.FileNames;
        while(*pName != '\0')
		{
            AppendStatus(pName);
            // Point to the next filename
			pName += _tcslen(pName) + 1;
		}

        //* Filter selected
        m_nFilterIndex = Params.FilterIndex;
	}

    //* Free memory if window is not modal thus is closed (we don't need it anymore)
    //* Else it will be freed in the callback!
    if(!m_cbNotModal)
	{
        FileSystemDialogs::FilesystemDialogs_FreeDialogResults(&Results);
	}

	UpdateData(FALSE);
}

/*****************************************************************************************
* Purpose:		Click handler for the "SaveDialog" button.
*****************************************************************************************/
void CFSDDlg::OnBnClickedBtnSaveDlg()
{
	LPTSTR pName;
	BOOL Success;

	UpdateData();
	//* Set params
	::ZeroMemory(&Params, sizeof(Params));
	Params.FileName = m_strFileName;
	Params.Filters = m_strFilters;
	Params.FilterIndex = m_nFilterIndex;

    Params.DialogType = fsdtSaveDialog;

	//* Modal or not (the NOT modal form is the suggested methode)
    //* This requires a Handle which to the message will be sent and/or a HookProc
    //* This is needed to free the resources at the session end
	if(m_cbNotModal)
	{
        Params.Options |= ofNotModal;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
        Params.HookProc = OFNHookProc;
	}

    //* Browser mode
	if(m_cbNoClose)
	{
		Params.Options |= ofNoClose;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
        Params.HookProc = OFNHookProc;
	}

	//* Stay on top?
    if(m_cbStayOnTop)
	{
        Params.Options |= ofStayOnTop;
	}

    //* Integrate the dialog into a parent panel
	if(m_cbIntegrate)
	{
		Params.Options |= ofIntegrate;
		//* Needed for non-Delphi host apps
		Params.Options |= ofCompatibilityMode;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
	}

    //* Send a message when selection changes
    //* This requires a Handle which to the message will be sent and/or a HookProc
    if(m_cbSelectFileName)
	{
		Params.Options |= ofOnSelectFileName;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
		Params.HookProc = OFNHookProc;
	}

    //* Identify this dialog (In VC++ Tools/Create GUID creates a new GUID)
	// {77D80DD5-2F88-4fe8-96ED-6099E6AE81FA}
	static const GUID id =
		{ 0x77d80dd5, 0x2f88, 0x4fe8, { 0x96, 0xed, 0x60, 0x99, 0xe6, 0xae, 0x81, 0xfa } };
    Params.DialogGUID = id;


    //* The app isn't commercial else you need a license
    Params.AllowTIFFLZW = true;

	//* Set up result structure
	::ZeroMemory(&Results, sizeof(Results));

    //* Inititalize the result structure (memory allocation)
	FileSystemDialogs::FilesystemDialogs_InitDialogResults(&Results, 1000);

    //* Call SaveDialog
    Success = FileSystemDialogs::FilesystemDialogs_SaveDialog(Params, &Results);
    //* Use result
	if(Results.Successfull)
	{
        //* Single file
		m_strFileName = Results.FileName;

        //* Extract files (multiple) ending with a double null
		m_status.Clear();
        pName = Results.FileNames;
        while(*pName != '\0')
		{
            AppendStatus(pName);
            // Point to the next filename
			pName += _tcslen(pName) + 1;
		}

        //* Filter selected
        m_nFilterIndex = Params.FilterIndex;
	}

	//* Free memory if window is not modal thus is closed (we don't need it anymore)
    //* Else it will be freed in the callback!
    if(!m_cbNotModal)
	{
        FileSystemDialogs::FilesystemDialogs_FreeDialogResults(&Results);
	}

	UpdateData(FALSE);
}

/*****************************************************************************************
* Purpose:		Click handler for the "FolderDialog" button.
*****************************************************************************************/
void CFSDDlg::OnBnClickedBtnFolderDlg()
{
	BOOL Success;

	UpdateData();
	//* Set params
	::ZeroMemory(&Params, sizeof(Params));
	TCHAR szDrive[_MAX_DRIVE];
	TCHAR szDirectory[_MAX_DIR];
	_tsplitpath(m_strFileName, szDrive, szDirectory, NULL, NULL);
	CString s(szDrive);
	s += szDirectory;
	Params.InitialDir = s;

	//* Modal or not (the NOT modal form is the suggested methode)
    //* This requires a Handle which to the message will be sent and/or a HookProc
    //* This is needed to free the resources at the session end
	if(m_cbNotModal)
	{
        Params.Options |= ofNotModal;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
        Params.HookProc = OFNHookProc;
	}

    //* Browser mode
	if(m_cbNoClose)
	{
		Params.Options |= ofNoClose;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
        Params.HookProc = OFNHookProc;
	}

	//* Stay on top?
    if(m_cbStayOnTop)
	{
        Params.Options |= ofStayOnTop;
	}

    //* Integrate the dialog into a parent panel
	if(m_cbIntegrate)
	{
		Params.Options |= ofIntegrate;
		//* Needed for non-Delphi host apps
		Params.Options |= ofCompatibilityMode;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
	}

    //* Send a message when selection changes
    //* This requires a Handle which to the message will be sent and/or a HookProc
    if(m_cbSelectFileName)
	{
		Params.Options |= ofOnSelectFileName;
        Params.ParentWindow = m_integrateParent.GetSafeHwnd();
		Params.HookProc = OFNHookProc;
	}

    //* Identify this dialog (In VC++ Tools/Create GUID creates a new GUID)
	// {3951BFB3-ED4B-4ec7-B0F3-56CB847BBEE0}
	static const GUID id =
			{ 0x3951bfb3, 0xed4b, 0x4ec7, { 0xb0, 0xf3, 0x56, 0xcb, 0x84, 0x7b, 0xbe, 0xe0 } };
    Params.DialogGUID = id;

	//* Set up result structure
	::ZeroMemory(&Results, sizeof(Results));

    //* Inititalize the result structure (memory allocation)
	FileSystemDialogs::FilesystemDialogs_InitDialogResults(&Results, 1000);

    //* Call FolderDialog
    Success = FileSystemDialogs::FilesystemDialogs_FolderDialog(Params, &Results);
    //* Use result
	if(Results.Successfull)
	{
        //* Single file
		m_strFileName = Results.FileName;

        //* Extract files (multiple) ending with a double null
		m_status.Clear();
        AppendStatus(Results.FileNames);
	}

	//* Free memory if window is not modal thus is closed (we don't need it anymore)
    //* Else it will be freed in the callback!
    if(!m_cbNotModal)
	{
        FileSystemDialogs::FilesystemDialogs_FreeDialogResults(&Results);
	}

	UpdateData(FALSE);
}


/*****************************************************************************************
* Purpose:		Click handler for the "Settings" button.
*****************************************************************************************/
void CFSDDlg::OnBnClickedBtnSettings()
{
	 //* Call FilesystemDialogs_SettingsWindow()
	BOOL Success = FileSystemDialogs::FilesystemDialogs_Settings();
    if(Success)
	{
		m_status.SetWindowText(_T("FilesystemDialogs_SettingsWindow(): OK.\r\n"));
	}
	else
	{
        m_status.SetWindowText(_T("FilesystemDialogs_SettingsWindow(): ERROR.\r\n"));
	}
}

/*****************************************************************************************
* Purpose:		Handler for the main dialog's resize event.
* Parameters:	See MSDN!
*****************************************************************************************/
void CFSDDlg::OnSizing(UINT fwSide, LPRECT pRect)
{
	CDialog::OnSizing(fwSide, pRect);
	DoLayout();
}

/*****************************************************************************************
* Purpose:		Resizes the controls of the dialog according to the window size.
*****************************************************************************************/
void CFSDDlg::DoLayout()
{
	RECT r;
	GetClientRect(&r);
	int nWidth = r.right - r.left;
	int nHeight = r.bottom - r.top;

	GetDlgItem(IDC_ED_FILENAME)->MoveWindow(10, 200, nWidth - 10 - 10, 20);
	m_status.MoveWindow(10, 225, nWidth - 10 - 10, 50);
	m_integrateParent.MoveWindow(10, 285, nWidth - 10 - 10 , nHeight - 285 - 10, TRUE);
	m_optionsGroup.MoveWindow(0, 0, nWidth, nHeight);

	if(m_FDWinHandle != NULL)
	{
		::SendMessage(m_FDWinHandle, FDM_REALIGN_INTEGRATED_WINDOW, 0, 0);
	}
}
