#include "StdAfx.h"
#include "FileSystemDialogsDefs.h"

namespace FileSystemDialogs
{
	static HMODULE FileSystemDialogsDLLHandle = NULL;
	bool FileSystemDialogsDLLLoaded = false;

	t_OpenDialog FilesystemDialogs_OpenDialog = NULL;
	t_SaveDialog FilesystemDialogs_SaveDialog = NULL;
	t_FolderDialog FilesystemDialogs_FolderDialog = NULL;
	t_FilesystemDialogsSettings FilesystemDialogs_Settings = NULL;
	t_InitTOpenDialogParams FilesystemDialogs_InitTOpenDialogParams = NULL;
	t_FreeTOpenDialogParams FilesystemDialogs_FreeTOpenDialogParams = NULL;
	t_InitTOpenDialogResults FilesystemDialogs_InitTOpenDialogResults = NULL;
	t_FreeTOpenDialogResults FilesystemDialogs_FreeTOpenDialogResults = NULL;
	

	/*****************************************************************************************
	* Purpose:		Initialize the FileSystem Dialogs library.
	* Returns:		true on success, false otherwise.
	*****************************************************************************************/
	bool InitFileSystemDialogsLibrary()
	{	
		FileSystemDialogsDLLHandle = ::LoadLibrary(FILENAME_DLL_FD);
		if(NULL != FileSystemDialogsDLLHandle)
		{
			FilesystemDialogs_OpenDialog			 = (t_OpenDialog)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_OpenDialog);
			FilesystemDialogs_SaveDialog             = (t_SaveDialog)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_SaveDialog);
			FilesystemDialogs_FolderDialog           = (t_FolderDialog)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_FolderDialog);
			FilesystemDialogs_Settings               = (t_FilesystemDialogsSettings)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_Settings);
			FilesystemDialogs_InitTOpenDialogParams  = (t_InitTOpenDialogParams)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_InitTOpenDialogParams);
			FilesystemDialogs_FreeTOpenDialogParams	 = (t_FreeTOpenDialogParams)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_FreeTOpenDialogParams);
			FilesystemDialogs_InitTOpenDialogResults = (t_InitTOpenDialogResults)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_InitTOpenDialogResults);
			FilesystemDialogs_FreeTOpenDialogResults = (t_FreeTOpenDialogResults)::GetProcAddress(FileSystemDialogsDLLHandle, NAME_FD_FreeTOpenDialogResults);

			if((NULL == FilesystemDialogs_OpenDialog)			
				|| (NULL == FilesystemDialogs_SaveDialog)           
				|| (NULL == FilesystemDialogs_FolderDialog)          
				|| (NULL == FilesystemDialogs_Settings)              
				|| (NULL == FilesystemDialogs_InitTOpenDialogParams)
				|| (NULL == FilesystemDialogs_FreeTOpenDialogParams)
				|| (NULL == FilesystemDialogs_InitTOpenDialogResults)
				|| (NULL == FilesystemDialogs_FreeTOpenDialogResults))
			{
				FileSystemDialogsDLLLoaded = false;
			} 
			else
			{
				FileSystemDialogsDLLLoaded = true;
			}
		}

		return FileSystemDialogsDLLLoaded;
	}

	/*****************************************************************************************
	* Purpose:		Free FileSystem Dialogs library.
	* Returns:		true on success, false otherwise.
	*****************************************************************************************/
	bool FreeFileSystemDialogsLibrary()
	{
		if (NULL != FileSystemDialogsDLLHandle)
		{
			FileSystemDialogsDLLLoaded = !::FreeLibrary(FileSystemDialogsDLLHandle);
		}
		return !FileSystemDialogsDLLLoaded;
	}
}
