/*
	Filesystem Dialogs Library simple console tutorial
	Copyright (c) 2016 www.3delite.hu

	Note: add an XP style manifest to the project to get styled dialogs.
*/

#define _UNICODE

//* Enable styles (else need to add a manifest)
#pragma comment(linker,"\"/manifestdependency:type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

#include <stdlib.h>
#include <stdio.h>
#include "Tchar.h"
#include "FilesystemDialogsDefs.h"
#include <Windows.h>

void main(int argc, char **argv)
{

	//* Load the FilesystemDialogs.dll
	if (!InitFilesystemDialogsLibrary()) {
		//* Could not load the .dll
		printf("\n\tError while loading FilesystemDialogs.dll.\n");
		return;
	}

	//* Call this function AFTER loading the FilesystemDialogs.dll
	SetProcessDPIAware;

	//* Structs for the dialog
	TOpenDialogParams Params;
	TOpenDialogResults Results;

	//* Always clear the struct
	ZeroMemory(&Params, sizeof(Params));
	//* Set parameters
	Params.DialogType = fsdtOpenDialog;
	//* OR flags together like this
	Params.Options = ofAllowMultiSelect | ofFileMustExist;

	//* Call the dialog
	if (FilesystemDialogs_OpenDialog(Params, &Results)) {
		//* Print 1st selected file name
		printf("\n%ws\n", Results.FileName);
	}
	else
	{
		printf("\nDialog canceled.\n");
	}

	//* Don't need the results any more
	FilesystemDialogs_FreeDialogResults(&Results);

	//* Unload the FilesystemDialogs.dll
	FreeFilesystemDialogsLibrary();
}
