Attribute VB_Name = "modFilesystemDialogs"

'//********************************************************************************************************************************
'//*                                                                                                                              *
'//*     Filesystem Dialogs Library 2.1.3.6829  3delite 2006-2024                                                                *
'//*     See Filesystem Dialogs Library ReadMe.txt for details.                                                                   *
'//*                                                                                                                              *
'//* Licenses available for usage of this component:                                                                              *
'//* Freeware License: 25                                                                                                        *
'//* 	http://www.shareit.com/product.html?productid=300958160                                                                   *
'//* Shareware License: 95                                                                                                       *
'//* 	http://www.shareit.com/product.html?productid=300070165                                                                   *
'//* Commercial License: 450                                                                                                     *
'//* 	http://www.shareit.com/product.html?productid=300070166                                                                   *
'//*                                                                                                                              *
'//* Home page:                                                                                                                   *
'//*                                                                                                                              *
'//*     https://www.3delite.hu/Object Pascal Developer Resources/filesystemdialogs.html                                          *
'//*                                                                                                                              *
'//* If you have any questions or enquiries please mail: 3delite@3delite.hu                                                       *
'//*                                                                                                                              *
'//* Good coding! :)                                                                                                              *
'//* 3delite                                                                                                                      *
'//********************************************************************************************************************************

Global Const FILENAME_DLL_FD = "FilesystemDialogs.dll"

Global Const WM_USER         = &0400

'//* Filesystem Dialogs messages
  '//* Pointer to TOpenDialogResults is in wParam
  '//* Pointer to TOpenDialogParams is in lParam
  '//* You get the messages in the hookproc and to the specified Parent window handle
Global Const FDM_BASE              = 2 * WM_USER + 1;

  '//* Filesystem Dialogs results message
Global Const FDM_RESULTS           = FDM_BASE + 1;

  '//* Load settings
Global Const FDM_LOADSETTINGS      = FDM_BASE + 2;

  '//* Free memory that you have allocated for the dialog('s params, results)
Global Const FDM_FREEMEM           = FDM_BASE + 3;

  '//* The dialog form is closing
Global Const FDM_CLOSING           = FDM_BASE + 4;

  '//* The dialog form's window handle in wParam
  '//* Pointer to TOpenDialogParams is in lParam
Global Const FDM_WINDOW_HANDLE     = FDM_BASE + 5;

  '//* Realing the integrated form to the parent
Global Const FDM_REALIGN_INTEGRATED_WINDOW = FDM_BASE + 6;

  '//* Sent on file name selection
  '//* File name is in wParam as PChar (unicode), item's PIDL is lParam
Global Const FDM_ON_SELECT_FILE_NAME = FDM_BASE + 7;

  '//* Refresh folder
Global Const FDM_REFRESH_FOLDER = FDM_BASE + 8;

  '//* Thumbnail is ready
Global Const FDM_THUMBNAIL_READY = FDM_BASE + 9;

  '//* Send thumbnail file name to thumbnail control thread
Global Const FDM_ADD_THUMBNAIL_FILENAME = FDM_BASE + 10;

  '//* Thumbnailer thread finished
Global Const FDM_THUMBNAILER_THREAD_FINISHED = FDM_BASE + 11;

  '//* Terminate thumbnailer control thread
Global Const FDM_THUMBNAILER_CONTROL_THREAD_TERMINATE = FDM_BASE + 12;

  '//* Secondary viewer picture thread finished
Global Const FDM_SECONDARYVIEWER_PICTURE_READY = FDM_BASE + 13;

  '//* Secondary viewer audio picture thread finished
Global Const FDM_SECONDARYVIEWER_AUDIOPICTURE_READY = FDM_BASE + 14;

  '//* Viewer audio picture thread finished
Global Const FDM_VIEWER_AUDIOPICTURE_READY = FDM_BASE + 15;

  '//* Custom previewer query file (wParam = PChar file name, lParam = PIDL)
Global Const FDM_PREVIEWER_CUSTOM_QUERY = FDM_BASE + 16;
  '//* Custom previewer open previewer (Wnd = handle for the panel, wParam = PChar file name, lParam = PIDL)
Global Const FDM_PREVIEWER_CUSTOM_DISPLAY = FDM_BASE + 17;
  '//* Custom previewer close
Global Const FDM_PREVIEWER_CUSTOM_CLOSE = FDM_BASE + 18;
  '//* Custom previewer resized
Global Const FDM_PREVIEWER_CUSTOM_RESIZED = FDM_BASE + 19;

  '//* Viewer audio picture progress
Global Const FDM_VIEWER_AUDIOPICTURE_PROGRESS = FDM_BASE + 20;

  '//* Secondary viewer audio picture progress
Global Const FDM_SECONDARYVIEWER_VIEWER_AUDIOPICTURE_PROGRESS = FDM_BASE + 21;

  '//* Navigate to folder specified as PIDL in WPARAM
Global Const FDM_NAVIGATE_TO_PIDL = FDM_BASE + 22;

  '//* Trigger sending of selected files and folders for hookproc
Global Const FDM_QUERY_SELECTED_ITEMS = FDM_BASE + 23;

  '//* Abort (stop) listing a folder
Global Const FDM_CANCEL_LISTING_ITEMS = FDM_BASE + 24;

  '//* Viewer animation GIF thread finished
Global Const FDM_VIEWER_GIFANIM_READY = FDM_BASE + 25;

  '//* Viewer animation GIF thread finished
Global Const FDM_SECONDARYVIEWER_GIFANIM_READY = FDM_BASE + 26;

  '//* Request the current folder, returns POpenDialogParams in LPARAM and POpenDialogOnCurrentFolder in WPARAM
Global Const FDM_GET_CURRENT_FOLDER = FDM_BASE + 27;

  '//* A dialog window is activated, returns POpenDialogParams in LPARAM and 0 in WPARAM
Global Const FDM_WINDOW_ACTIVATED = FDM_BASE + 28;

  '//* Activate a dialog window, LPARAM = 0, WPARAM = 0
Global Const FDM_WINDOW_ACTIVATE = FDM_BASE + 29;

  '//* Select all files and folders, LPARAM = 0, WPARAM = 0
Global Const FDM_SELECT_ALL = FDM_BASE + 30;

  '//* Invert selected and unselected files and folders, LPARAM = 0, WPARAM = 0
Global Const FDM_INVERT_SELECTION = FDM_BASE + 31;

  '//* Invert selected and unselected files and folders, LPARAM = POpenDialogSelectPattern, WPARAM = 0
Global Const FDM_SELECT_PATTERN = FDM_BASE + 32;

  '//* Current folder changed, WPARAM = PIDL, LPARAM = POpenDialogParams
Global Const FDM_CURRENT_FOLDER_CHANGED = FDM_BASE + 33;

  '//* Editing text, LPARAM = POpenDialogSelectPattern, WPARAM = 1 when started, 0 when exited
Global Const FDM_IN_EDIT = FDM_BASE + 34;

  '//* Deselect all files and folders, LPARAM = 0, WPARAM = 0
Global Const FDM_SELECT_NONE = FDM_BASE + 35;

  '//* Used internally
Global Const FDM_FOLDER_SIZE_RESULT = FDM_BASE + 36;

  '//* Get folder sizes, LPARAM = 0, WPARAM = 0
Global Const FDM_COUNT_FOLDER_SIZES = FDM_BASE + 37;

  '//* Display the search panel, LPARAM = 0, WPARAM = 0
Global Const FDM_SHOW_SEARCH_PANEL = FDM_BASE + 38;

  '//* Add a PIDL, LPARAM = 0, WPARAM = PIDL
Global Const FDM_ADD_PIDL_TO_LIST = FDM_BASE + 39;

  '//* Search completed, LPARAM = 0, WPARAM = 0
Global Const FDM_SEARCH_COMPLETED = FDM_BASE + 40;

  '//* Search completed, LPARAM = 0, WPARAM = TFDSearchProgress
Global Const FDM_SEARCH_PROGRESS = FDM_BASE + 41;

  '//* Style changed, LPARAM = 0, WPARAM = TFDStyleChanged
Global Const FDM_STYLE_CHANGED = FDM_BASE + 42;

  '//* Style changed, LPARAM = 0, WPARAM = NewHandle
Global Const FDM_HOST_HANDLE_CHANGED = FDM_BASE + 43;

type TOpenDialogParams
    DefaultExt As Long 'PChar;          //* Default extension
    FileName As Long 'PChar;            //* Default file name for Open/Save and Initial dir
    Filters As Long 'PChar;             //* Filters eg.: 'Image files (*.bmp,*.jpg)|*.bmp;*.jpg|All files|*.*'
    FilterIndex As Integer '            //* Filter to use default, 1-first, 2-second...
    HelpContext As Integer '            //* Help context (not yet implemented)
    InitialDir As Long 'PChar;          //* Initial folder, this is extracted first from FileName, if no FileName specified settings are used to decide which folder to use
    Options As Long 'TOpenOptions;      //* Dialog options (not all implemented so far), OR TOpenOption flags together
    OptionsEx As Long 'TOpenOptionsEx;  //* Extra Dialog options, specify panels to hide (not all implemented), OR TOpenOptionEx flags together
    Title As Long 'PChar;               //* Title to display as window's caption
    ParentWindow As Long 'HWND;         //* Parent window handle (needed for HookProc)
    DialogGUID As Long' TGUID;          //* Specifically identificate the dialog (separate dialogs inside an application - you can get the same dialog always with this flag)
    HookProc As Long 'OFNHookProc;      //* Hookproc (There are two: 1. for not modal mode result, and 2. for filter change event (avoid using it) - ParentWindow handle is also needed)
    DialogType As Long 'TFSDialogType;  //* Type of the dialog: Open/Save/Folder
    User As Long 'Pointer               //* User
    FileInfoHookProc As Long 'FDFileInfoHookProc; //* Callback that gives back custom file info
    FileInfoColumnName As Long 'PChar	//* Column name used for custom file info
    FileThumbnailHookProc As Long 'FDFileThumbnailHookProc //* Callback that gives back thumbnail
    Appearance As Long 'POpenDialogAppearance //* Set to nil to use default appearance
    AdditionalParameters As Long 'PChar;//* String list of additional parameters
End Type

'//* Filesystem dialog result
type TOpenDialogResults
    Successfull As Long 'BOOL;          '//* True: User pressed the Open/Save button or double-clicked on a file, False: User pressed Cancel or closed the window, or error (there is fallback to comdlg32.dll though)
    FileName As Long 'PChar;            '//* The filename with full path the user selected (only one) ending with a double null: "C:\Dir\Data.txt" + #0#0
    FileNameSize As Long 'Int64;        '//* FileName size in bytes (should be always at least MAX_PATH)
    FileCount As Long 'Cardinal;        '//* Number of files, if user selected multiple files then FileCount > 1
    FileNames As Long 'PChar;           '//* List of files in format "C:\Dir\Data.txt" + #0 + "D:\Folder\DataX.txt" separated by null characters ending with a double null
    FileNamesSize As Long 'Int64;       '//* FileNames size in bytes (it's up to you to validate last entry if all selected filenames don't fit into the FileNames - but always check with FileExists())
    FilterIndex As Long 'Integer;       '//* Filter's index the user selected 1-first, 2-second, etc...
End Type

'type
'  tagOFN = packed record
'    lStructSize: DWORD;
'    hWndOwner: HWND;
'    hInstance: HINST;
'    lpstrFilter: PAnsiChar;
'    lpstrCustomFilter: PAnsiChar;
'    nMaxCustFilter: DWORD;
'    nFilterIndex: DWORD;
'    lpstrFile: PAnsiChar;
'    nMaxFile: DWORD;
'    lpstrFileTitle: PAnsiChar;
'    nMaxFileTitle: DWORD;
'    lpstrInitialDir: PAnsiChar;
'    lpstrTitle: PAnsiChar;
'    Flags: DWORD;
'    nFileOffset: Word;
'    nFileExtension: Word;
'    lpstrDefExt: PAnsiChar;
'    lCustData: LPARAM;
'    lpfnHook: OFNHookProc;
'    lpTemplateName: PAnsiChar;
'    pvReserved: Pointer;
'    dwReserved: DWORD;
'    FlagsEx: DWORD;
'  end;

'type
'  tagOFNW = packed record
'    lStructSize: DWORD;
'    hWndOwner: HWND;
'    hInstance: HINST;
'    lpstrFilter: PWideChar;
'    lpstrCustomFilter: PWideChar;
'    nMaxCustFilter: DWORD;
'    nFilterIndex: DWORD;
'    lpstrFile: PWideChar;
'    nMaxFile: DWORD;
'    lpstrFileTitle: PWideChar;
'    nMaxFileTitle: DWORD;
'    lpstrInitialDir: PWideChar;
'    lpstrTitle: PWideChar;
'    Flags: DWORD;
'    nFileOffset: Word;
'    nFileExtension: Word;
'    lpstrDefExt: PWideChar;
'    lCustData: LPARAM;
'    lpfnHook: OFNHookProc;
'    lpTemplateName: PWideChar;
'    pvReserved: Pointer;
'    dwReserved: DWORD;
'    FlagsEx: DWORD;
'  end;

Declare Function FilesystemDialogs_OpenDialog Lib "FilesystemDialogs.dll" (ByVal Params As TOpenDialogParams, ByVal Results As TOpenDialogResults) As Long
Declare Function FilesystemDialogs_SaveDialog Lib "FilesystemDialogs.dll" (ByValParams: TOpenDialogParams, ByVal Results As TOpenDialogResults) As Long
Declare Function FilesystemDialogs_FolderDialog Lib "FilesystemDialogs.dll" (ByValParams: TOpenDialogParams, ByVal Results As TOpenDialogResults) As Long

Declare Function FilesystemDialogs_FilesystemDialogsSettings Lib "FilesystemDialogs.dll" (ByVal Params As PAnsiChar) As Long

Declare Function FilesystemDialogs_FreeDialogResults Lib "FilesystemDialogs.dll" (ByVal Struct As TOpenDialogResults) As Long

' callback functions

Private Sub OFNHookProc(ByVal Wnd As Long, Msg As Long, wParam As Integer, lParam As Integer) As Long 

'show progress

End Sub

